﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x404

namespace i8088W_Basic_Info_Csharp
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Int16 slot = 0;
        public MainPage()
        {
            this.InitializeComponent();
            Library_ver_txt.Text = String.Format("{0:X4}", pac8088WNet.pac8088W.LibVersion());
            Library_date_txt.Text = pac8088WNet.pac8088W.LibDate();
            Split_btn.IsEnabled = false;
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            slot = (Int16)slot_cbx.SelectedIndex;
            if (pac8088WNet.pac8088W.Init(slot) == 0)
            {
                Firmware_ver_txt.Text = String.Format("{0:X4}", pac8088WNet.pac8088W.FirmwareVersion(slot));
                Split_btn.IsEnabled = true;
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
                slot = -1;
            }
        }

        private void Split_btn_Click(object sender, RoutedEventArgs e)
        {
            Grid_sv.IsPaneOpen = !Grid_sv.IsPaneOpen;
        }

        private void I8088W_Basic_btn_Click(object sender, RoutedEventArgs e)
        {
            grid_fm.Navigate(typeof(Pages.I8088W_Basic), slot);
            Grid_sv.IsPaneOpen = false;
        }

        private void I9088_Basic_btn_Click(object sender, RoutedEventArgs e)
        {
            grid_fm.Navigate(typeof(Pages.I9088_Basic), slot);
            Grid_sv.IsPaneOpen = false;
        }

        private void I9088_Power_btn_Click(object sender, RoutedEventArgs e)
        {
            grid_fm.Navigate(typeof(Pages.I9088_Power_On), slot);
            Grid_sv.IsPaneOpen = false;
        }

        private void I9088_Safe_btn_Click(object sender, RoutedEventArgs e)
        {
            grid_fm.Navigate(typeof(Pages.I9088_Safe), slot);
            Grid_sv.IsPaneOpen = false;
        }

        private void I9088_DI_btn_Click(object sender, RoutedEventArgs e)
        {
            grid_fm.Navigate(typeof(Pages.I9088_DI), slot);
            Grid_sv.IsPaneOpen = false;
        }

        private void Exit_btn_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Exit();
        }
    }
}