﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=234238

namespace i8088W_Basic_Info_Csharp.Pages
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class I8088W_Basic : Page
    {
        Int16 slot = 0;
        TextBox[] FREQ_txt;
        TextBox[] Duty_txt;
        ComboBox[] Mode_cbx;
        TextBox[] Burst_txt;
        ComboBox[] Trigger_cbx;
        CheckBox[] SYNC_ckb;
        Button[] Set_btn;
        Button[] Start_btn;
        TextBox[] PWM_txt;
        TextBox[] DI_txt;
        Button[] State_btn;
        public I8088W_Basic()
        {
            Int16 i = 0;
            this.InitializeComponent();
            FREQ_txt = new TextBox[8] { F0_txt, F1_txt, F2_txt, F3_txt, F4_txt, F5_txt, F6_txt, F7_txt };
            Duty_txt = new TextBox[8] { D0_txt, D1_txt, D2_txt, D3_txt, D4_txt, D5_txt, D6_txt, D7_txt };
            Mode_cbx = new ComboBox[8] { M0_cbx, M1_cbx, M2_cbx, M3_cbx, M4_cbx, M5_cbx, M6_cbx, M7_cbx };
            Burst_txt = new TextBox[8] { B0_txt, B1_txt, B2_txt, B3_txt, B4_txt, B5_txt, B6_txt, B7_txt };
            Trigger_cbx = new ComboBox[8] { T0_cbx, T1_cbx, T2_cbx, T3_cbx, T4_cbx, T5_cbx, T6_cbx, T7_cbx };
            SYNC_ckb = new CheckBox[8] { S0_ckx, S1_ckx, S2_ckx, S3_ckx, S4_ckx, S5_ckx, S6_ckx, S7_ckx };
            Set_btn = new Button[8] { S0_btn, S1_btn, S2_btn, S3_btn, S4_btn, S5_btn, S6_btn, S7_btn };
            Start_btn = new Button[8] { ST0_btn, ST1_btn, ST2_btn, ST3_btn, ST4_btn, ST5_btn, ST6_btn, ST7_btn };
            PWM_txt = new TextBox[8] { O0_txt, O1_txt, O2_txt, O3_txt, O4_txt, O5_txt, O6_txt, O7_txt };
            DI_txt = new TextBox[8] { DI0_txt, DI1_txt, DI2_txt, DI3_txt, DI4_txt, DI5_txt, DI6_txt, DI7_txt };
            State_btn = new Button[8] { DI0_btn, DI1_btn, DI2_btn, DI3_btn, DI4_btn, DI5_btn, DI6_btn, DI7_btn};
            for (i = 0; i < 8; ++i)
            {
                Mode_cbx[i].SelectedIndex = 1;
            }
        }
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            slot = (Int16)e.Parameter;
        }

        private void SYNC_ckx_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            CheckBox ckb = sender as CheckBox;
            for (i = 0; i < 8; ++i)
            {
                if (ckb.Name == SYNC_ckb[i].Name)
                {
                    ch = i;
                    break;
                }
            }
            if (ckb.IsChecked.Value == true)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void Set_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            Button btn = sender as Button;
            for (i = 0; i < 8; ++i)
            {
                if (btn.Name == Set_btn[i].Name)
                {
                    ch = i;
                    break;
                }
            }
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cbx[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(Burst_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[i].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, (Int16)Trigger_cbx[ch].SelectedIndex);
        }

        private void Start_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            Button btn = sender as Button;
            for (i = 0; i < 8; ++i)
            {
                if (btn.Name == Start_btn[i].Name)
                {
                    ch = i;
                    break;
                }
            }
            if (btn.Content.ToString() == "Start")
            {
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
                btn.Content = "Stop";
            }
            else
            {
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
                btn.Content = "Start";
            }
        }

        private void SYNC_btn_Click(object sender, RoutedEventArgs e)
        {
            Button btn = sender as Button;
            if (btn.Content.ToString() == "SYNC Start")
            {
                pac8088WNet.pac8088W.Sync_Start(slot);
                btn.Content = "SYNC Stop";
            }
            else
            {
                pac8088WNet.pac8088W.Sync_Stop(slot);
                btn.Content = "SYNC Start";
            }
        }

        private void Read_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            Button btn = sender as Button;
            Int32 pwmState = 0;
            Int32[] pwmBitArr = new Int32[8];
            Int32 diVal = 0;
            Int32[] diBit = new Int32[8];
            for (i = 0; i < 8; ++i)
            {
                if (btn.Name == State_btn[i].Name)
                {
                    ch = i;
                    break;
                }
            }
            pac8088WNet.pac8088W.GetPWMActiveState(slot, ref pwmState, pwmBitArr);
            if (pwmBitArr[ch] == 1)
            {
                PWM_txt[ch].Text = "ON";
            }
            else
            {
                PWM_txt[ch].Text = "OFF";
            }
            pac8088WNet.pac8088W.GetDI(slot, ref diVal, diBit);
            if (diBit[ch] == 1)
            {
                DI_txt[ch].Text = "ON";
            }
            else
            {
                DI_txt[ch].Text = "OFF";
            }
        }
    }
}