﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=234238

namespace i8088W_Basic_Info_Csharp.Pages
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class I9088_DI : Page
    {
        Int16 slot = 0;
        TextBox[] DI_txt;
        public I9088_DI()
        {
            this.InitializeComponent();
            DI_txt = new TextBox[8] { DI0_txt, DI1_txt, DI2_txt, DI3_txt, DI4_txt, DI5_txt, DI6_txt, DI7_txt };
        }
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            slot = (Int16)e.Parameter;
        }

        private void Set_btn_Click(object sender, RoutedEventArgs e)
        {
            pac8088WNet.pac8088W.SetLowPassFilter(slot, int.Parse(LPF_txt.Text));
        }

        private void Read_DI_btn_Click(object sender, RoutedEventArgs e)
        {
            int i = 0;
            Int32 dival = 0;
            Int32[] dibit = new Int32[8];
            pac8088WNet.pac8088W.GetDI(slot, ref dival, dibit);
            for (i = 0; i < 8; ++i)
            {
                if (dibit[i] == 1)
                {
                    DI_txt[i].Text = "ON";
                }
                else
                {
                    DI_txt[i].Text = "OFF";
                }
            }
        }
    }
}