﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=234238

namespace i8088W_Basic_Info_Csharp.Pages
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class I9088_Safe : Page
    {
        Int16 slot = 0;
        public I9088_Safe()
        {
            this.InitializeComponent();
        }
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            slot = (Int16)e.Parameter;
        }

        private void Set_btn_Click(object sender, RoutedEventArgs e)
        {
            short en = 0;
            int overwrite = 0;
            pac8088WNet.pac8088W.WriteSafeValue(slot, Convert.ToUInt16(Safe_value_txt.Text, 16));
            if (Safe_en_ckb.IsChecked.Value == true)
            {
                en = 1;
            }
            else
            {
                en = 0;
            }
            if (Safe_over_ckb.IsChecked.Value == true)
            {
                overwrite = 1;
            }
            else
            {
                overwrite = 0;
            }
            pac8088WNet.pac8088W.SetModuleWDTConfig(slot, en, ushort.Parse(WDT_txt.Text), overwrite);
        }

        private void Start_btn_Click(object sender, RoutedEventArgs e)
        {
            if (Start_btn.Content.ToString() == "Start Refresh WDT")
            {
                Start_btn.Content = "Stop Refresh WDT";
                RefreshWDT();
            }
            else if (Start_btn.Content.ToString() == "Stop Refresh WDT")
            {
                Start_btn.Content = "Start Refresh WDT";
            }

        }
        void RefreshWDT()
        {
            while (true)
            {
                if (Start_btn.Content.ToString() == "Stop Refresh WDT")
                {
                    pac8088WNet.pac8088W.RefreshModuleWDT(slot);
                }
                Thread.Sleep(100);
            }
        }

        private void Reset_btn_Click(object sender, RoutedEventArgs e)
        {
            pac8088WNet.pac8088W.ResetModuleWDT(slot);
        }
    }
}
