﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace pac8088WNet
{
    public class pac8088W
    {
        private class ICPDAS
        {
            [DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetLibVersion")]
            public static extern Int16 pac_i8088W_GetLibVersion();
            [DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetLibDate")]
            public static extern void pac_i8088W_GetLibDate(byte[] libDate);
            [DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetFirmwareVersion")]
            public static extern Int16 pac_i8088W_GetFirmwareVersion(int Slot);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_Init")]
            public static extern Int16 pac_i8088W_Init(int Slot);
            [DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetPWMDutyCount")]
            public static extern Int16 pac_i8088W_SetPWMDutyCount(int slot, int ch, UInt32 Hi, UInt32 Lo);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetPWMDuty")]
            public static extern Int16 pac_i8088W_SetPWMDuty(int slot, int ch, UInt32 hz, UInt16 duty);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetPWMDuty_Deci")]
            public static extern Int16 pac_i8088W_SetPWMDuty_Deci(int slot, int ch, UInt32 deci_Hz, UInt16 deci_duty);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetPWMDuty_Float")]
            public static extern Int16 pac_i8088W_SetPWMDuty_Float(int slot, int ch, float f_hz, float f_duty);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetRealPWMDuty_Deci")]
            public static extern Int16 pac_i8088W_GetRealPWMDuty_Deci(int slot, int ch, ref UInt32 deci_Hz, ref UInt16 deci_duty);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetPWMCountMode")]
            public static extern Int16 pac_i8088W_SetPWMCountMode(int slot, int ch, byte countMode);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetBurstCount")]
            public static extern Int16 pac_i8088W_SetBurstCount(int slot, int ch, UInt16 burstCount);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_PWM_Start")]
            public static extern Int16 pac_i8088W_PWM_Start(int slot, int ch);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_PWM_Stop")]
            public static extern Int16 pac_i8088W_PWM_Stop(int slot, int ch);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetSyncChannel")]
            public static extern Int16 pac_i8088W_SetSyncChannel(int slot, int ch, Int16 enBit);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetSyncChannel")]
            public static extern Int16 pac_i8088W_GetSyncChannel(int slot, int ch, ref Int16[] sycArr);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_Sync_Start")]
            public static extern Int16 pac_i8088W_Sync_Start(int slot);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_Sync_Stop")]
            public static extern Int16 pac_i8088W_Sync_Stop(int slot);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetHardwareTrigChannel")]
            public static extern Int16 pac_i8088W_SetHardwareTrigChannel(int slot, int ch, Int32 triggerState);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetHardwareTrigChannel")]
            public static extern Int16 pac_i8088W_GetHardwareTrigChannel(int slot, int ch, ref Int32 triggerState);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetDI")]
            public static extern Int16 pac_i8088W_GetDI(int slot, ref Int32 diVal, Int32[] diBitArr);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetPWMActiveState")]
            public static extern Int16 pac_i8088W_GetPWMActiveState(int slot, ref Int32 pwmOutputState, Int32[] activeArray);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetLowPassFilter")]
			public static extern Int16 pac_i8088W_SetLowPassFilter(int slot,int val);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetLowPassFilter")]
			public static extern Int16 pac_i8088W_GetLowPassFilter(int slot,ref int val);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetPowerOnMode")]
			public static extern Int16 pac_i8088W_SetPowerOnMode(int slot,Int16 mode);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetPowerOnMode")]
			public static extern Int16 pac_i8088W_GetPowerOnMode(int slot,ref Int16 mode);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_WritePowerOnValue")]
			public static extern Int16 pac_i8088W_WritePowerOnValue(int slot,uint DOval);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_ReadPowerOnValue")]
			public static extern Int16 pac_i8088W_ReadPowerOnValue(int slot,ref uint DOval);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_WriteSafeValue")]
			public static extern Int16 pac_i8088W_WriteSafeValue(int slot,uint DOval);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_ReadSafeValue")]
			public static extern Int16 pac_i8088W_ReadSafeValue(int slot,ref uint DOval);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_SetModuleWDTConfig")]
			public static extern Int16 pac_i8088W_SetModuleWDTConfig(int slot,Int16 enStatus,UInt16 wdtTimeout,int is_Overwrite);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetModuleWDTConfig")]
			public static extern Int16 pac_i8088W_GetModuleWDTConfig(int slot,ref Int16 enStatus,ref UInt16 wdtTimeout,ref int is_Overwrite);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_RefreshModuleWDT")]
			public static extern Int16 pac_i8088W_RefreshModuleWDT(int slot);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_GetModuleWDTStatus")]
			public static extern Int16 pac_i8088W_GetModuleWDTStatus(int slot);
			[DllImport("pac_i8088W_UWP_x64.dll", EntryPoint = "pac_i8088W_ResetModuleWDT")]
			public static extern Int16 pac_i8088W_ResetModuleWDT(int slot);
        }
        public static Int16 LibVersion()
        {
            return ICPDAS.pac_i8088W_GetLibVersion();
        }
        public static Int16 FirmwareVersion(int slot)
        {
            return ICPDAS.pac_i8088W_GetFirmwareVersion(slot);
        }
        public static string LibDate()
        {
            byte[] libDate = new byte[32];
            ICPDAS.pac_i8088W_GetLibDate(libDate);
            return AscArr2Str(libDate);
        }
        public static Int16 Init(int slot)
        {
            return ICPDAS.pac_i8088W_Init(slot);
        }
        private static string AscArr2Str(byte[] b)
        {
            return System.Text.UnicodeEncoding.Unicode.GetString(
            System.Text.ASCIIEncoding.Convert(System.Text.Encoding.ASCII,
            System.Text.Encoding.Unicode, b), 0, b.Length);
        }
        public static string Arr2Str(byte[] buffer)
        {
            return (new UnicodeEncoding()).GetString(buffer, 0, buffer.Length);
        }
        public static Int16 SetPWMDutyCount(int slot, int ch, UInt32 Hi, UInt32 Lo)
        {
            return ICPDAS.pac_i8088W_SetPWMDutyCount(slot, ch, Hi, Lo);
        }
        public static Int16 SetPWMDuty(int slot, int ch, UInt32 hz, UInt16 duty)
        {
            return ICPDAS.pac_i8088W_SetPWMDuty(slot, ch, hz, duty);
        }
        public static Int16 SetPWMDuty_Deci(int slot, int ch, UInt32 deci_Hz, UInt16 deci_duty)
        {
            return ICPDAS.pac_i8088W_SetPWMDuty_Deci(slot, ch, deci_Hz, deci_duty);
        }
        public static Int16 SetPWMDuty_Float(int slot, int ch, float f_hz, float f_duty)
        {
            return ICPDAS.pac_i8088W_SetPWMDuty_Float(slot, ch, f_hz, f_duty);
        }
        public static Int16 GetRealPWMDuty_Deci(int slot, int ch, ref UInt32 deci_Hz, ref UInt16 deci_duty)
        {
            return ICPDAS.pac_i8088W_GetRealPWMDuty_Deci(slot, ch, ref deci_Hz, ref deci_duty);
        }
        public static Int16 SetPWMCountMode(int slot, int ch, byte countMode)
        {
            return ICPDAS.pac_i8088W_SetPWMCountMode(slot, ch, countMode);
        }
        public static Int16 SetBurstCount(int slot, int ch, UInt16 burstCount)
        {
            return ICPDAS.pac_i8088W_SetBurstCount(slot, ch, burstCount);
        }
        public static Int16 PWM_Start(int slot, int ch)
        {
            return ICPDAS.pac_i8088W_PWM_Start(slot, ch);
        }
        public static Int16 PWM_Stop(int slot, int ch)
        {
            return ICPDAS.pac_i8088W_PWM_Stop(slot, ch);
        }
        public static Int16 SetSyncChannel(int slot, int ch, Int16 enBit)
        {
            return ICPDAS.pac_i8088W_SetSyncChannel(slot, ch, enBit);
        }
        public static Int16 GetSyncChannel(int slot, int ch, ref Int16[] sycArr)
        {
            return ICPDAS.pac_i8088W_GetSyncChannel(slot, ch, ref sycArr);
        }
        public static Int16 Sync_Start(int slot)
        {
            return ICPDAS.pac_i8088W_Sync_Start(slot);
        }
        public static Int16 Sync_Stop(int slot)
        {
            return ICPDAS.pac_i8088W_Sync_Stop(slot);
        }
        public static Int16 SetHardwareTrigChannel(int slot, int ch, int triggerState)
        {
            return ICPDAS.pac_i8088W_SetHardwareTrigChannel(slot, ch, triggerState);
        }
        public static Int16 GetHardwareTrigChannel(int slot, int ch, ref int triggerState)
        {
            return ICPDAS.pac_i8088W_GetHardwareTrigChannel(slot, ch, ref triggerState);
        }
        public static Int16 GetDI(int slot, ref Int32 diVal, Int32[] diBitArr)
        {
            Int16 ret = -1;
            ret = ICPDAS.pac_i8088W_GetDI(slot, ref diVal, diBitArr);
            return ret;
        }
        public static Int16 GetPWMActiveState(int slot, ref Int32 pwmOutputState, Int32[] activeArray)
        {
            return ICPDAS.pac_i8088W_GetPWMActiveState(slot, ref pwmOutputState, activeArray);
        }
		public static Int16 SetLowPassFilter(int slot,int val)
		{
			return ICPDAS.pac_i8088W_SetLowPassFilter(slot,val);
		}
		public static Int16 GetLowPassFilter(int slot,ref int val)
		{
			return ICPDAS.pac_i8088W_GetLowPassFilter(slot,ref val);
		}
		public static Int16 SetPowerOnMode(int slot,Int16 mode)
		{
			return ICPDAS.pac_i8088W_SetPowerOnMode(slot,mode);
		}
		public static Int16 GetPowerOnMode(int slot,ref Int16 mode)
		{
			return ICPDAS.pac_i8088W_GetPowerOnMode(slot,ref mode);
		}
		public static Int16 WritePowerOnValue(int slot,uint DOval)
		{
			return ICPDAS.pac_i8088W_WritePowerOnValue(slot,DOval);
		}
		public static Int16 ReadPowerOnValue(int slot,ref uint DOval)
		{
			return ICPDAS.pac_i8088W_ReadPowerOnValue(slot,ref DOval);
		}
		public static Int16 WriteSafeValue(int slot,uint DOval)
		{
			return ICPDAS.pac_i8088W_WriteSafeValue(slot,DOval);
		}
		public static Int16 ReadSafeValue(int slot,ref uint DOval)
		{
			return ICPDAS.pac_i8088W_ReadSafeValue(slot,ref DOval);
		}
		public static Int16 SetModuleWDTConfig(int slot,Int16 enStatus,UInt16 wdtTimeout,int is_Overwrite)
		{
			return ICPDAS.pac_i8088W_SetModuleWDTConfig(slot,enStatus,wdtTimeout,is_Overwrite);
		}
		public static Int16 GetModuleWDTConfig(int slot,ref Int16 enStatus,ref UInt16 wdtTimeout,ref int is_Overwrite)
		{
			return ICPDAS.pac_i8088W_GetModuleWDTConfig(slot,ref enStatus,ref wdtTimeout,ref is_Overwrite);
		}
		public static Int16 RefreshModuleWDT(int slot)
		{
			return ICPDAS.pac_i8088W_RefreshModuleWDT(slot);
		}
		public static Int16 GetModuleWDTStatus(int slot)
		{
			return ICPDAS.pac_i8088W_GetModuleWDTStatus(slot);
		}
		public static Int16 ResetModuleWDT(int slot)
		{
			return ICPDAS.pac_i8088W_ResetModuleWDT(slot);
		}
    }
}